/*       GACCTEST.C                                            */
/*                                                             */
/*       Testprogramm fr GSZRZ mit appl_read / appl_write.    */
/*                                                             */


/* Dieses Beispiel soll nur veranschaulichen, wie GSZRZ ber das
   appl_write ansprechbar ist. Es ist keine vollstndige Implementation
   des XACC Protokolls! */


/* GACCTEST mu von GACCTEST.PRG in GACCTEST.GTP umbenannt werden, 
   damit eine Parameterbergabe beim Start mglich ist. Pure-C
   erkennt immer noch nicht .GTP als gltige Extension.

   Umbenennen in GACCTEST.TTP ist nicht mglich, da sonst kein
   Fenster von GSZRZ geffnet werden kann.
*/


/*

GACCTEST muss folgendermassen aufgerufen werden :

    -sz .......    oder -rz ......

Die Reihenfolge der Parameter ist hier wichtig. Fr MultiTOS
sollte der Dateiname IMMER mit komplettem Pfad bergeben werden,
da GSZRZ sonst die Datei nicht findet, selbst wenn sie im aktuellen
Pfad liegt. Fr das ACC ist der aktuelle Pfad der, aus dem es 
gestartet wurde, und nicht der, aus dem GACCTEST aufgerufen wurde.

*/




#include <aes.h>
#include <stdio.h>
#include <string.h>


int main( int argc, char **argv )
{
	int i;
	int MsgTxBuffer[8];
	int MsgRxBuffer[128];
	int ap_Ruf;
	int ap_id;
	int ereignis, ret;
	char buffer[128];
	char *retmsg;

	char CommandLine[128];					/* be shure this buffer exists while GSZRZ is working! */
											/* it should not be destroyed because it takes some time */
											/* to parse the commandline */


	/* init command line */

	memset( CommandLine, 0, sizeof(CommandLine));
	i = 1;

	while(i < argc)
	{
		strcat(CommandLine,argv[i++]);
		strcat(CommandLine," ");
	}

	ap_id = appl_init( );

	if ( ap_id != -1 )
	{
		ap_Ruf = appl_find("GSZRZ_30");									/* search for the ACC */
		if (ap_Ruf < 0)
		{
			ap_Ruf = appl_find("GSZRZ_ST");
		}
		if (ap_Ruf < 0)
			form_alert( 1,"[1][GSZRZ ACC not found][ Grmpf ] ");
		else
		{

			/* preset private message to the GSZRZ ACC */

			MsgTxBuffer[0] = 'GZ';
			MsgTxBuffer[1] = ap_id;
			MsgTxBuffer[2] = -1;
			MsgTxBuffer[3] = (int)strlen(CommandLine);					/* length of commandline	*/
			MsgTxBuffer[4] = (unsigned int)((unsigned long)CommandLine & 0XFFFF); /* low part of pointer		*/
			MsgTxBuffer[5] = (unsigned int)((unsigned long)CommandLine >> 16);	  /* high part of pointer		*/
			MsgTxBuffer[6] = 0;
			MsgTxBuffer[7] = 0;
			appl_write(ap_Ruf, 16, MsgTxBuffer);						/* send message				*/


			/* wait for the answer */

			do
			{
			    ereignis = evnt_multi(MU_MESAG | MU_TIMER,				/* wait for events			*/
									0,0,0,								/* button					*/
									0,0,0,0,0,							/* no mouse 1				*/
									0,0,0,0,0,							/* no mouse 2				*/
									MsgRxBuffer,						/* evnt_mesag				*/
									1000,0,								/* short delay				*/
									&ret,&ret,&ret,						/* evnt_mouse				*/
									&ret,								/* ev_mmokstate				*/
									&ret,								/* key code					*/
									&ret);								/* evnt_mouse				*/
			}while((ereignis != MU_MESAG) || (MsgRxBuffer[0] != 'GZ'));

			retmsg = (char *) (((unsigned long) MsgRxBuffer[4] & 0xFFFFL) +
					   (((unsigned long) MsgRxBuffer[5] << 16) & 0xFFFF0000L));

			sprintf(buffer,"[1][%s|Exitcode: %d][ OK ]", retmsg, MsgRxBuffer[2]);
			form_alert(1, buffer);				

		}
		appl_exit( );
		return( MsgRxBuffer[2]);
	}
	return(-1);
}
